import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ArchiveProviderConfig {
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/archive#alias ArchiveProvider#alias}
    */
    readonly alias?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/archive archive}
*/
export declare class ArchiveProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "archive";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/archive archive} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ArchiveProviderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: ArchiveProviderConfig);
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
